C+
	SUBROUTINE PLNPLT(R,ANGS,ANGS2,ALINE,DASHL,SIZE,UPPER)
C
C	Plots the fault and auxiliary planes of a focal mechanism
C	solution.
C
C	29 September 1985:  Added upper hemisphere plot option
C-
	DIMENSION ANGS(3),ANGS2(3),X(181),Y(181)
	character*4 aline
	LOGICAL UPPER,XRTMAX,YTPMAX
	DATA XRTMAX,YTPMAX/2*.TRUE./
	RDEG = 45.0/ATAN(1.0)
	JCOUNT = 1
	TAKOFF = (90.0 - ANGS(1))/RDEG
	ANG = ANGS(1)
	IF (UPPER) THEN
	  STRYK = (180.0 + ANGS(2))/RDEG
	ELSE
	  STRYK = ANGS(2)/RDEG
	END IF
100	IF (ANG .EQ. 0.0) GO TO 600
	CSTRYK = COS(STRYK)
	SSTRYK = SIN(STRYK)
	FACTOR = R/SQRT(2.0)
	SINT = SIN(TAKOFF)
	COST = COS(TAKOFF)
	DO 500 J=1,181
	IF (.NOT.(J .EQ. 1 .OR. J .EQ. 181)) GO TO 200
	  X1 = 0.0
	  IF (J .EQ. 1) Y1 = -R
	  IF (J .EQ. 181) Y1 = R
	  GO TO 400
200	IF (.NOT. (J .EQ. 91)) GO TO 300
	  Y1 = 0.0
	  X1 = SQRT(2.0)*R*SIN(0.5*TAKOFF)
	  GO TO 400
300	ANGLE = FLOAT(J-91)/RDEG
	AT = ATAN2(SINT,TAN(ANGLE))
	F2 = SQRT(2.0*(1.0 - COS(ANGLE)*COST))
	X1 = FACTOR*F2*SIN(AT)
	Y1 = FACTOR*F2*COS(AT)
400	X(J) = Y1*SSTRYK + X1*CSTRYK
500	Y(J) = Y1*CSTRYK - X1*SSTRYK
      CALL PLTDAT(X,0.0,-R,1.0,-R,R,
     .            Y,-R,-R,R,1.0,181,ALINE,DASHL,SIZE,
     .            NSYMBL,1,'XLIN','YLIN',XRTMAX,YTPMAX)
600	IF (JCOUNT .EQ. 2) GO TO 700
	  JCOUNT = 2
	  TAKOFF = (90.0 - ANGS2(1))/RDEG
	  ANG = ANGS2(1)
	  IF (UPPER) THEN
	    STRYK = (180.0 + ANGS2(2))/RDEG
	  ELSE
	    STRYK = ANGS2(2)/RDEG
	  END IF
	  GO TO 100
  700	CALL TSEND
      RETURN
      END
